//-----------------------------------------------------------------------
//	SDRAM_CNTRL.v
//		SDRAM Controller skeleton for EECS150 Lab Checkpoint
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Create your FSM and any other circuit to generate all your control
//	signals here. You can modify any part of this module but do not
//	remove or modify any of the PORT signals that are already there.
//	You can add more signals in the module interface.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// 	The initialize and lode mode register waveforms are given in page
//	37 of the datasheet
//	
//	Power up -> NOP for min 100us -> Precharge -> NOP -> AutoRefresh
//	-> NOP -> AutoRefresh -> NOP -> Load Mode Register -> NOP
//	-> Active Operations
//
//	SDRAM Configuration
//	a.	Burst length of 4 for both read and write
//	b.	Sequential order of bursts
//	c.	CAS latency of 2
//	d.	Standard operation
//
//-----------------------------------------------------------------------
module sdram_cntrl (	 
		//-------------------------------------------------------
		//	These signals must be present in your sdram_cntrl module
		//-------------------------------------------------------
		RAM_D_EN,		// to SDRAM
		RAM_CLK,		// to SDRAM
		RAM_CLKE,		// to SDRAM
		RAM_DQMH,		// to SDRAM
		RAM_DQML,		// to SDRAM
		RAM_CS,			// to SDRAM
		RAM_RAS,		// to SDRAM
		RAM_CAS,		// to SDRAM
		RAM_WE,			// to SDRAM
		RAM_BA,			// to SDRAM
		RAM_A,			// to SDRAM
		Clock, 			// from FPGA
		Reset,			// from FPGA
		TimeSelect		// from dip-switches
		//-------------------------------------------------------

		//-------------------------------------------------------
		//	You can add as many signals here as you deem
		//	necessary here
		//-------------------------------------------------------
		//-------------------------------------------------------
		 );

	//---------------------------------------------------------------
	//	SDRAM Tristate Databus Control
	//---------------------------------------------------------------
	output		RAM_D_EN;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	SDRAM Control and Address
	//---------------------------------------------------------------
	output		RAM_CLK;
	output		RAM_CLKE;
	output		RAM_DQMH;
	output		RAM_DQML;
	output		RAM_CS;
	output		RAM_RAS;
	output		RAM_CAS;
	output		RAM_WE;
	output	[1:0]	RAM_BA;
	output	[11:0]	RAM_A;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Misc.
	//---------------------------------------------------------------
	input		Clock;
	input		Reset;
	input	[15:0]	TimeSelect;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Declare state encoding parameters
	//---------------------------------------------------------------
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Declare Wires and Regs
	//---------------------------------------------------------------
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Create CurrentState Register
	//---------------------------------------------------------------
	//---------------------------------------------------------------   

	//---------------------------------------------------------------
	//	Main FSM Always Block
	//---------------------------------------------------------------
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Generate PN_Generator Control Signals
	//---------------------------------------------------------------
	//---------------------------------------------------------------


	//---------------------------------------------------------------
	//	Generate FIFO Control Signals
	//---------------------------------------------------------------
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Use TimeSelect to start reading after programmable delay
	//---------------------------------------------------------------
	//---------------------------------------------------------------


	//---------------------------------------------------------------
	//	Create more debugging wires
	//---------------------------------------------------------------
	//---------------------------------------------------------------

endmodule
